//***************************************************************************
//*  (K) Kopyright 1997-1998 K!Prod, DefCoN Mag Video Librairy, by ArraKiS  *
//*  Feel free to use but do distribute the complete package (V0.30)       *
//*                                                                         *
//*  Thanks to EgoN/K!Prod for all the Info about VESA 2.0                  *
//*  Thanks to Babylon/Revelation for his VESA LIBRARY SOURCE V2.0          *
//*  Now, my ChkVesa and ChkVesaMode are clean and structured!              *
//*  Created (DefCoN #1) : 15/06/97  (V0.1)                                *
//*  Complete Rewrite    : 25/09/97  (V0.2)                                *
//*  Last Update         : 25/06/98  (V0.30)                               * 
//***************************************************************************

#ifndef _KVIDEO_H_
#define _KVIDEO_H_

typedef unsigned short WORD;
typedef unsigned int DWORD;
typedef unsigned char BYTE;

typedef unsigned short word;
typedef unsigned int dword;
typedef unsigned char byte;

#define Boolean int
#define True 1
#define False 0

#define ON 1
#define OFF 0

typedef struct { char *Address;
                 word X,Y,BPP;
               } VideoBuffer;

/*typedef struct
{  word  VESA_SelectMode;      // Mode Selectionner
   word  VESA_SelectModeMaxX;
   word  VESA_SelectModeMaxY;
   byte  VESA_SelectModeBPP;   // BPP Rel
   byte  VESA_SelectTrueBPP;   // BPP "Hard" (pour calculer le mapping size)
   byte  ModeX_Engaged;        // ModeX
   byte  VESAX_Engaged;        // VesaX 
   byte  Flags[2];             // Not Used Yet
   dword X_Modif_offset;       // Offset of CRTC Values
   dword VESA_MapSize;         // Taille de l'ecran (?)
   dword VESA_BPSL;            // Bytes Per Scan Line
   dword VESA_LFB;             // Is LFB availaible ??
   byte  *VESA_Address;        // Pointer to VIDEO RAM (or use this)
   dword VESA_WindowSize;      // Taille de la fenetre (default:64Ko)
   dword VESA_BANKTable[128];
   dword VESA_SetBankPtr;      // Pointer to BankSwitch function rm&pm
   dword VESA_NbBanks;         // Nombre de Banks
   dword VESA_CurrentBank;     // Current used bank
   dword VESA_PMInterf;        // Protected Mode interface found ?
   dword VESA_PMBSwitch;       // use P-Mode bank switch ?
} ModeInfos; */

#ifdef __cplusplus
extern "C" {
#endif

extern char *error_message[];

// Variables ...
extern char KVversion[];               // Version de la librairy K!Video

extern BYTE ReturnCode;                // Code de Retour

extern BYTE  VESAX_Engaged;            // VESAX ??
extern BYTE  ModeX_Engaged;            // ModeX ??
extern WORD  VESA_SelectMode;          // Mode Selectionne
extern WORD  VESA_SelectModeMaxX;      // Resolution X selectionne
extern WORD  VESA_SelectModeMaxY;      // Resolution Y selectionne
extern BYTE  VESA_SelectModeBPP;       // BitPerPixel selectionne
extern BYTE  VESA_SelectTrueBPP;       // BitPerPixel Hard 

extern DWORD VESA_MapSize;             // Taille de l'ecran (?)
extern DWORD VESA_BPSL;                // Bytes Per Scan Line
extern BYTE  VESA_LFB;                 // Is LFB availaible ??
extern BYTE *VESA_Address;             // Video Adresse in Linear
extern BYTE  VESA_PMInterf;            // Protected Mode interface found ?
extern BYTE  VESA_PMBSwitch;           // use P-Mode bank switch ?

extern char  VESA_Form[4];             // Signature VESA
extern WORD  VESA_Version;             // Version de VESA
extern WORD  VESA_RAM;                 // Taille de la RAM Video
extern DWORD VESA_RAMo;                // Taille de la RAM Video (en octets!)

extern DWORD VESA_NbMode;
extern WORD  VESA_ModeList[5*256];     // Video Mode List with :
                             // Width, Height, bpp, mode number & BipMapping

extern BYTE  VESAChecked;

// ** C procedures ***

extern VideoBuffer GetVideoBuffer( word X, word Y, word BPP);
extern void FreeVideoBuffer(VideoBuffer enreg);
extern int  SelectMode(int X, int Y, int BPP);
extern void Copy2Screen(char* Address);
extern void ClrScr(void);
extern void BlackPal(void);
extern void SetPal(byte *WP);
extern void SetZPal(byte *WP, byte deb, byte fin);
extern void FadeP1ToP2(byte P1[], byte P2[], int frames);
extern void FadePal2Black (byte PaletteIn[], int frames);
extern void FadeNow2Black (int frames);
extern void FadePalFromBlack (byte PaletteIn[], int frames);
extern void FadePalZone2Black (byte PaletteIn[], int frames,byte deb, byte fin);
extern void MakeFadePal(byte cstart, byte r1, byte g1, byte b1,
                        byte cend,   byte r2, byte g2, byte b2);
extern void WriteModeInfo(void);
extern void SwapPointer(char *_1st,char *_2nd);
extern int  readGIF(byte *nomfic,byte *dest,byte *pal);
extern int  SearchMode(word X, word Y, word BPP);

// *** Asm Procedure ***
//;  *** Main Functions ***
extern void ChkVESA(void);
extern int  ChkVESAMode(dword x, dword y, dword bpp);
extern int  ChkModeX(dword x, dword y, dword bpp);
extern void InitMode13h(void);
extern void SetMode(void);
extern void CloseMode(void);
extern void VSwpscrLFB(char *source);
extern void VSwpscrBAN(char *source);
extern void VSwpscrM_X(char *source);
extern void ClsVbuf(char *BufferVideo);
extern void ClsLFB(void);
extern void ClsBAN(void);
extern void ClsM_X(void);
extern void ModeText(void);
extern void WaitVbl(void);

//  *** Misc Functions ***
extern void MemCopy(char *source, char*dest, dword longueur);
extern void lisgif(char *source, char *destination);
extern int  IsVGA(void);
extern void ScreenOn(void);
extern void ScreenOff(void);
extern void CPULine(void);
/*extern void SaveModeInfos(ModeInfos *dest);
extern void RestoreModeInfos(ModeInfos *Source);*/

//  *** Beta Functions ***
extern void Buffer32ToScreen16LFB(byte *Buffer);
extern void readTGAr32(char *buffer, char *fichier, int size);

//  *** Palette Functions ***
extern void SetColor(DWORD Pen, byte  R,byte  G,byte  B);
extern void GetPal(byte *WP);

#ifdef __cplusplus
};
#endif

#endif
